#include "mainwindow.h"

#define CRASH 1

MainWindow::MainWindow(QWidget *parent)
   : QMainWindow(parent), cam_(NULL)
{
   QPushButton *button = new QPushButton("Start Cam");
   connect(button, SIGNAL(pressed()), this, SLOT(start()));
   setCentralWidget(button);
}

MainWindow::~MainWindow()
{
   stop();
}

void MainWindow::start()
{
   if (!cam_)
   {
      cam_ = new QQuickWidget();

      cam_->setSource(QUrl("qrc:///declarative-camera.qml"));
      cam_->setResizeMode(QQuickWidget::SizeRootObjectToView);

      connect(cam_->engine(), SIGNAL(quit()),
              this, SLOT(stop()));
   }

   cam_->show();
   cam_->raise();

   hide();
}

void MainWindow::stop()
{
   if (cam_)
   {
      cam_->hide();
      cam_->lower();

      show();

#if CRASH
      delete cam_;
#else
      cam_->deleteLater();
#endif

      cam_ = NULL;
   }
}
